stages:
  - build
  - vault
  - provision
  - staging
  - prod
  - destroy

include:
  - project: 'otus6/pipeline/docker-build'
    file: '.docker-build.yml'
  - project: 'otus6/pipeline/get-secrets'
    file: '.get-secrets.yml'
  - project: 'otus6/pipeline/terraform-apply'
    file: '.terraform-apply.yml'
  - project: 'otus6/pipeline/deploy-ansible'
    file: '.deploy-ansible.yml'
  - project: 'otus6/pipeline/terraform-destroy'
    file: '.terraform-destroy.yml'





# build-staging:      # build job name should has "build-" prefix
#   stage: build
#   extends: .docker-build
#   tags:
#     - dind_lms
#   except:
#   - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'

# build-prod:         # build job name should has "build-" prefix
#   stage: build
#   extends: .docker-build
#   tags:
#     - dind_lms
#   only:
#     refs:
#       - master
#       - tags

secrets-staging:
  stage: vault
  extends: 
    - .get-secrets
  variables:
    VAULT_SECRETS: "otus6/secrets/${CI_PROJECT_NAME}"
    TOOLS: "ansible terraform"
  tags:
    - dind_lms
  except:
  - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'

secrets-prod:
  stage: vault
  extends: 
    - .get-secrets
  variables:
    VAULT_SECRETS: "otus6/secrets/${CI_PROJECT_NAME}"
    TOOLS: "ansible terraform"
  tags:
    - dind_lms
  only:
    refs:
      - master
      - tags

provision-staging:
  stage: provision
  extends: .terraform-apply  
  allow_failure: true
  dependencies:
    - secrets-staging
  tags:
    - dind_lms
  except:
  - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'

provision-prod:
  stage: provision
  extends: .terraform-apply  
  allow_failure: true
  dependencies:
    - secrets-prod
  tags:
    - dind_lms
  only:
    refs:
      - master
      - tags

deploy-staging:
  stage: staging
  extends:
    - .deploy-ansible    
  variables:
    DEPLOY_DOMAIN: "lms-otus.ml"
    # DEPLOY_HOST: "35.205.104.77"
    ANSIBLE_ROLES_STORE: "galaxy"
  allow_failure: true
  dependencies:
    - secrets-staging
    - provision-staging
  tags:
    - dind_lms
  except:
  - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'

deploy-prod:
  stage: prod
  extends:
    - .deploy-ansible        
  variables:
    DEPLOY_DOMAIN: "lms-otus.ml"
    # DEPLOY_HOST: "35.205.104.77"
    ANSIBLE_ROLES_STORE: "galaxy"
  allow_failure: true
  dependencies:
    - secrets-prod
    - provision-prod
  tags:
    - dind_lms
  only:
    refs:
      - master
      - tags

destroy-staging:
  stage: destroy
  extends: .terraform-destroy
  dependencies:
    - provision-staging
  tags:
    - dind_lms
  except:
  - /^(?!master).+@/    # Ruby RegEx for anything not starting with 'master'

destroy-prod:
  stage: destroy 
  extends: .terraform-destroy
  dependencies:
    - provision-prod
  tags:
    - dind_lms
  only:
    refs:
      - master
      - tags
